<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmPerfilDeAtividadeService;

class CrmPerfilDeAtividadeController
{
    protected $PerfilDeAtividadeService;

    use TResponse;

    public function __construct(CrmPerfilDeAtividadeService $CrmPerfilDeAtividadeService)
    {
        $this->PerfilDeAtividadeService = $CrmPerfilDeAtividadeService;
    }

    public function getCrmPerfilDeAtividade()
    {
        try {
            $data = $this->PerfilDeAtividadeService->getCrmPerfilDeAtividade();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCrmPerfilDeAtividadeOperador(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->getCrmPerfilDeAtividadeOperador($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveCrmPerfilDeAtividade(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->saveCrmPerfilDeAtividade($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function deleteCrmPerfilDeAtividade(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->deleteCrmPerfilDeAtividade($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
      
        }  
    }

    public function getCrmPerfilDeAtividadeOperadores(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->getCrmPerfilDeAtividadeOperadores($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCrmPerfilModalMetas(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->getCrmPerfilModalMetas($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCrmPerfilDeAtividadeMetas(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->getCrmPerfilDeAtividadeMetas($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveCrmPerfilOperador(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->saveCrmPerfilOperador($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }


    public function saveCrmPerfilMeta(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $data = $this->PerfilDeAtividadeService->saveCrmPerfilMeta($rows);
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}