<?php

namespace CRM\Service;

use CRM\Factory\CrmNovoDashboardFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;
use Guzzle\Http\Message\Request;

class CrmNovoDashboardService
{

    protected $DashboardFactory;
    protected $Environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $Environment, NewCode $newCode, EntityManager $entityManager, CrmNovoDashboardFactory $DashboardFactory)
    {
        $this->DashboardFactory             = $DashboardFactory;
        $this->Environment                  = $Environment;
        $this->newCode                      = $newCode;
        $this->connection                   = $entityManager->getConnection();
    }

    public function getTasks()
    {
        try {
            $nrorg = $this->Environment->getNrorg();
            $user = $this->Environment->getCurrentUserId();

            $params = array(
                "NRORG" => $nrorg,
                "NROPERADOR" => $user
            );
            
            return $this->DashboardFactory->getTasks($params);
        } catch (\Error $e) {
            throw $e;
        }
    }

    public function getTasksCards($periodo)
    {
        try {
            $nrorg = $this->Environment->getNrorg();
            $user = $this->Environment->getCurrentUserId();

            $params = array(
                "NRORG" => $nrorg,
                "NROPERADOR" => $user
            );
            
            return $this->DashboardFactory->getTasksCards($params, $periodo);
        } catch (\Error $e) {
            throw $e;
        }
    }

    public function getOportunities()
    {
        try {
            $nrorg = $this->Environment->getNrorg();
            $user = $this->Environment->getCurrentUserId();
            
            $params = array(
                "NRORG" => $nrorg,
                "NROPERADOR" => $user
            );
            
            return $this->DashboardFactory->getOportunities($params);
        } catch (\Error $e) {
            throw $e;
        }
    }

    public function getLeads($request)
    {
        try {
            $nrorg = $this->Environment->getNrorg();
            $user = $this->Environment->getCurrentUserId();
            $params = array(
                "NRORG" => $nrorg,
                "NRPARCPROPRI" => $user
            );
            
            return $this->DashboardFactory->getLeads($params);
        } catch (\Error $e) {
            throw $e;
        }
    }

    public function getLosts($request)
    {
        try {
            $nrorg = $this->Environment->getNrorg();
            $user = $this->Environment->getCurrentUserId();
            $params = array(
                "NRORG" => $nrorg,
                "NROPERADOR" => $user
            );
            
            return $this->DashboardFactory->getLosts($params);
        } catch (\Error $e) {
            throw $e;
        }
    }

    public function getLostsChart($request)
    {
        try {
            $nrorg = $this->Environment->getNrorg();
            $user = $this->Environment->getCurrentUserId();
            $params = array(
                "NRORG" => $nrorg,
                "NROPERADOR" => $user
            );
            
            return $this->DashboardFactory->getLostsChart($params);
        } catch (\Error $e) {
            throw $e;
        }
    }

}